import { FileUploadControl } from './../helpers/control.class';
import { ElementRef, OnDestroy, Renderer2, ChangeDetectorRef, OnInit, InputSignal, Signal, InputSignalWithTransform } from '@angular/core';
import { Subscription } from 'rxjs';
import * as i0 from "@angular/core";
export declare const HAS_FILES_CLASS_NAME = "has-files";
export declare const IS_INVALID_CLASS_NAME = "ng-invalid";
export declare const DRAGOVER_CLASS_NAME = "dragover";
export declare const TOUCHED_CLASS_NAME = "ng-touched";
export declare abstract class FileUploadAbstract implements OnInit, OnDestroy {
    readonly control: InputSignal<FileUploadControl>;
    readonly input: Signal<ElementRef<HTMLInputElement>>;
    readonly label: Signal<ElementRef<HTMLLabelElement>>;
    readonly isMultiple: InputSignalWithTransform<boolean, boolean | string>;
    protected readonly hooks: Array<Function>;
    protected readonly subscriptions: Array<Subscription>;
    protected readonly hostElementRef: ElementRef;
    protected readonly renderer: Renderer2;
    protected readonly cdr: ChangeDetectorRef;
    protected onChange: (v: Array<File>) => void;
    protected onTouch: () => void;
    constructor();
    ngOnInit(): void;
    ngOnDestroy(): void;
    /**
     * register function which will be called on UI change
     * to update view -> model
     */
    registerOnChange(fn: (v: Array<File>) => void): void;
    registerOnTouched(fn: any): void;
    protected unregisterEvents(): void;
    protected registerEvents(): void;
    protected clearInputEl(): void;
    /**
     * used to update model once state is changed through @Input
     * or in case of simple-file-upload to override user value
     */
    protected checkAndSetMultiple(): void;
    protected getControlInstance(): FileUploadControl;
    private hasFiles;
    private isInvalid;
    private checkAndSetFilesClass;
    private checkAndSetInvalidClass;
    private triggerEvent;
    private updateAcceptAttr;
    private checkAndMarkAsDisabled;
    private toggleMultiple;
    /**
     * ControlValueAccessor implementation
     */
    private connectToForm;
    static ɵfac: i0.ɵɵFactoryDeclaration<FileUploadAbstract, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<FileUploadAbstract, never, never, { "control": { "alias": "control"; "required": false; "isSignal": true; }; "isMultiple": { "alias": "multiple"; "required": false; "isSignal": true; }; }, {}, never, never, true, never>;
}
//# sourceMappingURL=file-upload-abstract.component.d.ts.map