import { TemplateRef, Signal, InputSignalWithTransform } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { AnimationEvent } from '@angular/animations';
import { FileUploadService } from './../../services/file-upload.service';
import { FileUploadAbstract } from './../file-upload-abstract.component';
import { FileUploadControl } from './../../helpers/control.class';
import * as i0 from "@angular/core";
export declare class FileUploadComponent extends FileUploadAbstract implements ControlValueAccessor {
    fileUploadService: FileUploadService;
    private document;
    animation: InputSignalWithTransform<boolean, boolean | string>;
    templateRef: Signal<TemplateRef<any>>;
    listItem: Signal<TemplateRef<any>>;
    templateContext: {
        $implicit: boolean;
        isFileDragDropAvailable: boolean;
    };
    /** animation fields */
    zoomText: 'zoomOut' | 'zoomIn' | 'static';
    listVisible: boolean;
    constructor(fileUploadService: FileUploadService, document: any);
    get isAnimationDisabled(): boolean;
    protected getListItemTemplateContext(index: number, item: File): {
        $implicit: File;
        file: File;
        index: number;
        control: FileUploadControl;
    };
    protected trackByFn(index: number, item: File): string;
    protected registerEvents(): void;
    onKeyDown(event: KeyboardEvent): void;
    private preventDragEvents;
    private renderView;
    private showList;
    private hideList;
    private toggleListVisibility;
    /**
     * on file over add class name
     */
    private onDragOver;
    /**
     * on mouse out remove class name
     */
    private onDragLeave;
    onDrop(event: Event): void;
    onInputChange(event: Event): void;
    /**
     * model -> view changes
     */
    writeValue(files: any): void;
    setDisabledState(isDisabled: boolean): void;
    zoomAnimationDone(event: AnimationEvent): void;
    animationListFinished(event: AnimationEvent): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<FileUploadComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<FileUploadComponent, "file-upload:not([simple])", never, { "animation": { "alias": "animation"; "required": false; "isSignal": true; }; }, {}, ["templateRef", "listItem"], never, true, never>;
}
//# sourceMappingURL=file-upload.component.d.ts.map